class pg_group : public GenericVideoFilter {  
	PVideoFrame frame;

public:
	pg_group(AVSValue polygons, IScriptEnvironment* env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env) { return frame;  }
};

int GCD(int a, int b) {
	if (b == 0) return a;
	return GCD(b, a%b);
}

int LCM(int a, int b) {
	return a*(b / GCD(a, b));
}

pg_group::pg_group(AVSValue polygons, IScriptEnvironment* env):GenericVideoFilter(polygons[0].AsClip()) {
//	float* src = (float*)_child->GetFrame(0, env)->GetReadPtr();
//	if (vi.height != 1 || ((int*)src)[0] != 0x594c4f50) env->ThrowError("Not a polygon");
	int i,j,k;
	int w = 1;

// sort
	int* fn = (int*)malloc(polygons.ArraySize()*sizeof(int));
	int* lt = (int*)calloc(polygons.ArraySize(),sizeof(int));

	for (i = 0; i < polygons.ArraySize(); i++) {
		w = LCM(w, (polygons[i].AsClip()->GetVideoInfo().width - HEADERS) >> 1);
		fn[i] = ((int*)(polygons[i].AsClip()->GetFrame(0, env)->GetReadPtr()))[1];
		j = 0;
		while (j < i) {
			if (fn[j] <= fn[i]) lt[i]++;
			else if (fn[j] > fn[i]) lt[j]++;
//			else env->ThrowError("Equal frame numbers, can't group");
			j++;
		}
	}

	for (i = 0; i < polygons.ArraySize(); i++) {
		fn[lt[i]] = i;
		debug("%d: %d", lt[i], i);
	}

	vi.width = HEADERS + (w << 1);
	vi.height = 1 + polygons.ArraySize();

//	int p;
//	int nv = (vi.width - HEADERS) >> 1;
//	double ox, oy;

	frame = env->NewVideoFrame(vi);
//	float* dst = (float*)frame->GetWritePtr();

/*
	memcpy(dst, src, HEADERS << 2);

	if (t > 1) {
		ox = 0; oy = 0;
		p = HEADERS;
		for (i = 0; i < nv; i++) {
			ox += src[p++];
			oy += src[p++];
		}
		ox = ox*(1.0 / nv);
		oy = oy*(1.0 / nv);
	}

	debug("%f,%f", x, y);

	switch (t) {
		case 1: {
			p = HEADERS;
			for (i = 0; i < nv; i++) {
				dst[p] = (float)(src[p]+x); p++;
				dst[p] = (float)(src[p]+y); p++;
			}
		} break;
		case 2: {
			p = HEADERS;
			for (i = 0; i < nv; i++) {
				dst[p] = (float)((src[p] - ox)*x + ox); p++;
				dst[p] = (float)((src[p] - oy)*y + oy); p++;
			}
		} break;
		case 3: {
			p = HEADERS;
			x = -x*M_PI*(1.0 / 180.0);
			for (i = 0; i < nv; i++) {
				dst[p] = (float)(((src[p] - ox)*cos(x) + (src[p + 1] - oy)*-sin(x))+ox); p++;
				dst[p] = (float)(((src[p - 1] - ox)*sin(x) + (src[p] - oy)*cos(x))+oy); p++;
			}
		} break;
	}
*/
}

AVSValue __cdecl Create_pg_group(AVSValue args, void* user_data, IScriptEnvironment* env) {
  return new pg_group(args[0], env);
}
