class pg_set : public GenericVideoFilter {  
//	VideoInfo vi;
	PVideoFrame frame;

public:
	pg_set(PClip _child, int _t, AVSValue _v, IScriptEnvironment* env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env) { return frame; }
};

pg_set::pg_set(PClip _child, int _t, AVSValue _v, IScriptEnvironment* env):GenericVideoFilter(_child) {
	void* src = (void*)_child->GetFrame(0, env)->GetReadPtr();
	if (vi.height != 1 || ((int*)src)[0] != 0x594c4f50) env->ThrowError("Not a polygon");

	frame = env->NewVideoFrame(vi);
	void* dst = (void*)frame->GetWritePtr();
	memcpy(dst, src, vi.width << 2);

	switch (_t) {
		case 1: ((int*)dst)[_t] = _v.AsInt(); break;
		case 2: ((float*)dst)[_t] = (float)_v.AsFloat(); break;
		case 3: ((float*)dst)[_t] = (float)_v.AsFloat(); break;
	}
}

AVSValue __cdecl Create_pg_set(AVSValue args, void* user_data, IScriptEnvironment* env) {
  return new pg_set(args[0].AsClip(), (int)user_data, args[1], env);
}
